void get_port(unsigned long base_addr, unsigned long len);
void clean_up();
void set_port_data(unsigned char dat);
unsigned char get_port_status();
unsigned char get_port_control();
unsigned char get_port_data();
void set_port_status(unsigned char dat);
void set_port_control(unsigned char dat);
void display_data(unsigned char data);
void display_address(unsigned char address);
void write_enable_bit();
void display_control(unsigned char control);
unsigned char display_read(unsigned char mask);
void delay_done();
void disp_init(unsigned short port_base_addr, unsigned char port_len);
void line_2(void);
void display_string(char *pointer);
void load_cg_ram(void);
void load_eight_bytes(unsigned char data);
void calc_bar_g_display(float load, int chars);
int daemon_init(float version);
void syslog_temp_stat(void);
void syslog_send(unsigned char *syslog_string_ptr);
void syslog_open(void);
float get_temp(unsigned char type);
void send_dallas(unsigned long protocol, unsigned long data);
void send_dallas_primitive(unsigned long data, unsigned char count);
unsigned long read_dallas(unsigned long protocol, unsigned char bits);
void dallas_reset(void);
void dallas_init(void);
int main(int argc, char *argv[]);
int init_fifo(void);
void remain_chars(void);
int read_fifo(void);
int display_fifo_buf(void);
int check_and_display_fifo(void);
void alt_temp(void);
void alt_mode(void);
void display_time(void);
void log_temp(void);
/*
 * 
 *  Structures and global variables
 * 
 */
 
struct fifo_dat {
/* pipe-holders */
unsigned char in_pipe_name[81];
unsigned char input[256];	/* 256 bytes of input buffer */
unsigned char *p_input_buf_base;/* Pointer to the input buffer base */
unsigned char *p_input_buf_offset;
				/* current char in use */
unsigned char line_0_buf[41];	/* Buffers for the display */
unsigned char line_1_buf[41];
unsigned char line_0_ready;
unsigned char line_1_ready;
unsigned int  update;		/* Counter to see when display last updated */
				/* with information from the input FIFO */
unsigned char input_fd;
unsigned char init_ok;
} fifo;

/* A place to store information from the Dallas 1620 Temp sensor */
struct dallas_data {
unsigned long raw_temperature;
unsigned long protocol;
unsigned long stat;
unsigned char sensor_ok;
float result;
unsigned char minus;
long holding;
unsigned long count_per_c;
unsigned long count_remain;
float degrees_f;
float degrees_c;
float offset;
unsigned char temp_display_type;
float min_c;
float max_c;
float min_f;
float max_f;
unsigned char last_min_time[32];
unsigned char last_max_time[32];
} dal_dat;

/* data used in the display of a bar graph on the LCD */
struct bar_graph_data {
float load;
int max;
int full_chars;
float step_max;
float step;
int bars;
char annot;
char remain_bars;
unsigned char final_char;
unsigned char display_string[32];
} bar_g;

/* cursor pos. data structure */
struct disp_cur_pos {
int cur_current_pos;
int cur_remain_chars;
int cur_line;
char auto_fill;
char fill_data;
} disp_cp;

enum temp_state {TEMP_INVALID, TEMP_VALID};

pid_t	pid;
time_t	clock_time;

/* pipe holder */
char in_str[40] = "/dev/lpt_driver_in\0";

/* the system info structure from kernel.h */
struct sysinfo sysin;
struct sysinfo *sysin_ptr = &sysin;

/* syslog driver strings and pointers... */
char syslog_string[81];
char *syslog_string_ptr = (char *)&syslog_string;
char syslog_ident[20] = "lpt_driver";
char *syslog_ident_ptr = (char *)&syslog_ident;

/* for the example, we use lp0 */
unsigned long port_base_addr = PORT_BASE;

/* 3 ports total */
unsigned long port_len = 3;

/* and an unsigned short for iob() calls */
unsigned short k_port_base = PORT_BASE;

/* enumerated stuff */
enum display_size {e_20x2,e_24x2,e_40x2} disp_size;

/* Display modes */
enum mode { PROCS,
	    CLOCK, 
	    PROCS_TEXTLOAD, 
	    CLOCK_TEXTLOAD, 
	    MIN_TEMP, 
	    MAX_TEMP, 
	    MY_PID, 
	    CLOCK_PROCS };


